com.io7m.r2.filters

## Class R2ShaderFilterBilateralBlurDepthAwareParameters

- java.lang.Object
- - com.io7m.r2.filters.R2ShaderFilterBilateralBlurDepthAwareParameters

- All Implemented Interfaces:
    R2ShaderFilterBilateralBlurDepthAwareParametersType

      @Generated(value={"Immutables.generator","R2ShaderFilterBilateralBlurDepthAwareParametersType"})
      public final class R2ShaderFilterBilateralBlurDepthAwareParameters
      extends Object
      implements R2ShaderFilterBilateralBlurDepthAwareParametersType

  The type of parameters for bilateral depth-aware blur shaders.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `R2ShaderFilterBilateralBlurDepthAwareParameters.Builder` Builds instances of type `R2ShaderFilterBilateralBlurDepthAwareParameters`.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `float` | `blurFalloff()`
    `float` | `blurOutputInverseHeight()`
    `float` | `blurOutputInverseWidth()`
    `float` | `blurRadius()`
    `float` | `blurSharpness()`
    `static R2ShaderFilterBilateralBlurDepthAwareParameters.Builder` | `builder()` Creates a builder for `R2ShaderFilterBilateralBlurDepthAwareParameters`.
    `static R2ShaderFilterBilateralBlurDepthAwareParameters` | `copyOf(R2ShaderFilterBilateralBlurDepthAwareParametersType instance)` Creates an immutable copy of a `R2ShaderFilterBilateralBlurDepthAwareParametersType` value.
    `float` | `depthCoefficient()`
    `R2Texture2DUsableType` | `depthTexture()`
    `boolean` | `equals(Object another)` This instance is equal to all instances of `R2ShaderFilterBilateralBlurDepthAwareParameters` that have equal attribute values.
    `int` | `hashCode()` Computes a hash code from attributes: `viewMatrices`, `imageTexture`, `depthTexture`, `depthCoefficient`, `blurFalloff`, `blurRadius`, `blurSharpness`, `blurOutputInverseWidth`, `blurOutputInverseHeight`.
    `R2Texture2DUsableType` | `imageTexture()`
    `static R2ShaderFilterBilateralBlurDepthAwareParameters` | `of(R2MatricesObserverValuesType viewMatrices, R2Texture2DUsableType imageTexture, R2Texture2DUsableType depthTexture, float depthCoefficient, float blurFalloff, float blurRadius, float blurSharpness, float blurOutputInverseWidth, float blurOutputInverseHeight)` Construct a new immutable `R2ShaderFilterBilateralBlurDepthAwareParameters` instance.
    `String` | `toString()` Prints the immutable value `R2ShaderFilterBilateralBlurDepthAwareParameters` with attribute values.
    `R2MatricesObserverValuesType` | `viewMatrices()`
    `R2ShaderFilterBilateralBlurDepthAwareParameters` | `withBlurFalloff(float value)` Copy the current immutable object by setting a value for the `blurFalloff` attribute.
    `R2ShaderFilterBilateralBlurDepthAwareParameters` | `withBlurOutputInverseHeight(float value)` Copy the current immutable object by setting a value for the `blurOutputInverseHeight` attribute.
    `R2ShaderFilterBilateralBlurDepthAwareParameters` | `withBlurOutputInverseWidth(float value)` Copy the current immutable object by setting a value for the `blurOutputInverseWidth` attribute.
    `R2ShaderFilterBilateralBlurDepthAwareParameters` | `withBlurRadius(float value)` Copy the current immutable object by setting a value for the `blurRadius` attribute.
    `R2ShaderFilterBilateralBlurDepthAwareParameters` | `withBlurSharpness(float value)` Copy the current immutable object by setting a value for the `blurSharpness` attribute.
    `R2ShaderFilterBilateralBlurDepthAwareParameters` | `withDepthCoefficient(float value)` Copy the current immutable object by setting a value for the `depthCoefficient` attribute.
    `R2ShaderFilterBilateralBlurDepthAwareParameters` | `withDepthTexture(R2Texture2DUsableType value)` Copy the current immutable object by setting a value for the `depthTexture` attribute.
    `R2ShaderFilterBilateralBlurDepthAwareParameters` | `withImageTexture(R2Texture2DUsableType value)` Copy the current immutable object by setting a value for the `imageTexture` attribute.
    `R2ShaderFilterBilateralBlurDepthAwareParameters` | `withViewMatrices(R2MatricesObserverValuesType value)` Copy the current immutable object by setting a value for the `viewMatrices` attribute.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Method Detail

    - #### viewMatrices

          public R2MatricesObserverValuesType viewMatrices()

      Specified by:
        `viewMatrices` in interface `R2ShaderFilterBilateralBlurDepthAwareParametersType`
      Returns:
        The matrices that were used to produce the scene being blurred

    - #### imageTexture

          public R2Texture2DUsableType imageTexture()

      Specified by:
        `imageTexture` in interface `R2ShaderFilterBilateralBlurDepthAwareParametersType`
      Returns:
        The image texture that will be blurred

    - #### depthTexture

          public R2Texture2DUsableType depthTexture()

      Specified by:
        `depthTexture` in interface `R2ShaderFilterBilateralBlurDepthAwareParametersType`
      Returns:
        The depth texture that will be sampled to determine the contribution of each corresponding pixel in the image texture

    - #### depthCoefficient

          public float depthCoefficient()

      Specified by:
        `depthCoefficient` in interface `R2ShaderFilterBilateralBlurDepthAwareParametersType`
      Returns:
        The depth coefficient used to produce the scene

    - #### blurFalloff

          public float blurFalloff()

      Specified by:
        `blurFalloff` in interface `R2ShaderFilterBilateralBlurDepthAwareParametersType`
      Returns:
        The blur falloff

    - #### blurRadius

          public float blurRadius()

      Specified by:
        `blurRadius` in interface `R2ShaderFilterBilateralBlurDepthAwareParametersType`
      Returns:
        The radius of the blur effect in texels

    - #### blurSharpness

          public float blurSharpness()

      Specified by:
        `blurSharpness` in interface `R2ShaderFilterBilateralBlurDepthAwareParametersType`
      Returns:
        The blur sharpness

    - #### blurOutputInverseWidth

          public float blurOutputInverseWidth()

      Specified by:
        `blurOutputInverseWidth` in interface `R2ShaderFilterBilateralBlurDepthAwareParametersType`
      Returns:
        The inverse width of the output image: (1 / width)

    - #### blurOutputInverseHeight

          public float blurOutputInverseHeight()

      Specified by:
        `blurOutputInverseHeight` in interface `R2ShaderFilterBilateralBlurDepthAwareParametersType`
      Returns:
        The inverse height of the output image: (1 / height)

    - #### withViewMatrices

          public final R2ShaderFilterBilateralBlurDepthAwareParameters withViewMatrices(R2MatricesObserverValuesType value)

      Copy the current immutable object by setting a value for the `viewMatrices` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for viewMatrices
      Returns:
        A modified copy of the `this` object

    - #### withImageTexture

          public final R2ShaderFilterBilateralBlurDepthAwareParameters withImageTexture(R2Texture2DUsableType value)

      Copy the current immutable object by setting a value for the `imageTexture` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for imageTexture
      Returns:
        A modified copy of the `this` object

    - #### withDepthTexture

          public final R2ShaderFilterBilateralBlurDepthAwareParameters withDepthTexture(R2Texture2DUsableType value)

      Copy the current immutable object by setting a value for the `depthTexture` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for depthTexture
      Returns:
        A modified copy of the `this` object

    - #### withDepthCoefficient

          public final R2ShaderFilterBilateralBlurDepthAwareParameters withDepthCoefficient(float value)

      Copy the current immutable object by setting a value for the `depthCoefficient` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for depthCoefficient
      Returns:
        A modified copy of the `this` object

    - #### withBlurFalloff

          public final R2ShaderFilterBilateralBlurDepthAwareParameters withBlurFalloff(float value)

      Copy the current immutable object by setting a value for the `blurFalloff` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for blurFalloff
      Returns:
        A modified copy of the `this` object

    - #### withBlurRadius

          public final R2ShaderFilterBilateralBlurDepthAwareParameters withBlurRadius(float value)

      Copy the current immutable object by setting a value for the `blurRadius` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for blurRadius
      Returns:
        A modified copy of the `this` object

    - #### withBlurSharpness

          public final R2ShaderFilterBilateralBlurDepthAwareParameters withBlurSharpness(float value)

      Copy the current immutable object by setting a value for the `blurSharpness` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for blurSharpness
      Returns:
        A modified copy of the `this` object

    - #### withBlurOutputInverseWidth

          public final R2ShaderFilterBilateralBlurDepthAwareParameters withBlurOutputInverseWidth(float value)

      Copy the current immutable object by setting a value for the `blurOutputInverseWidth` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for blurOutputInverseWidth
      Returns:
        A modified copy of the `this` object

    - #### withBlurOutputInverseHeight

          public final R2ShaderFilterBilateralBlurDepthAwareParameters withBlurOutputInverseHeight(float value)

      Copy the current immutable object by setting a value for the `blurOutputInverseHeight` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for blurOutputInverseHeight
      Returns:
        A modified copy of the `this` object

    - #### equals

          public boolean equals(Object another)

      This instance is equal to all instances of `R2ShaderFilterBilateralBlurDepthAwareParameters` that have equal attribute values.
      Overrides:
        `equals` in class `Object`
      Returns:
        `true` if `this` is equal to `another` instance

    - #### hashCode

          public int hashCode()

      Computes a hash code from attributes: `viewMatrices`, `imageTexture`, `depthTexture`, `depthCoefficient`, `blurFalloff`, `blurRadius`, `blurSharpness`, `blurOutputInverseWidth`, `blurOutputInverseHeight`.
      Overrides:
        `hashCode` in class `Object`
      Returns:
        hashCode value

    - #### toString

          public String toString()

      Prints the immutable value `R2ShaderFilterBilateralBlurDepthAwareParameters` with attribute values.
      Overrides:
        `toString` in class `Object`
      Returns:
        A string representation of the value

    - #### of

          public static R2ShaderFilterBilateralBlurDepthAwareParameters of(R2MatricesObserverValuesType viewMatrices,
                                                                           R2Texture2DUsableType imageTexture,
                                                                           R2Texture2DUsableType depthTexture,
                                                                           float depthCoefficient,
                                                                           float blurFalloff,
                                                                           float blurRadius,
                                                                           float blurSharpness,
                                                                           float blurOutputInverseWidth,
                                                                           float blurOutputInverseHeight)

      Construct a new immutable `R2ShaderFilterBilateralBlurDepthAwareParameters` instance.
      Parameters:
        `viewMatrices` - The value for the `viewMatrices` attribute
        `imageTexture` - The value for the `imageTexture` attribute
        `depthTexture` - The value for the `depthTexture` attribute
        `depthCoefficient` - The value for the `depthCoefficient` attribute
        `blurFalloff` - The value for the `blurFalloff` attribute
        `blurRadius` - The value for the `blurRadius` attribute
        `blurSharpness` - The value for the `blurSharpness` attribute
        `blurOutputInverseWidth` - The value for the `blurOutputInverseWidth` attribute
        `blurOutputInverseHeight` - The value for the `blurOutputInverseHeight` attribute
      Returns:
        An immutable R2ShaderFilterBilateralBlurDepthAwareParameters instance

    - #### copyOf

          public static R2ShaderFilterBilateralBlurDepthAwareParameters copyOf(R2ShaderFilterBilateralBlurDepthAwareParametersType instance)

      Creates an immutable copy of a `R2ShaderFilterBilateralBlurDepthAwareParametersType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
      Parameters:
        `instance` - The instance to copy
      Returns:
        A copied immutable R2ShaderFilterBilateralBlurDepthAwareParameters instance

    - #### builder

          public static R2ShaderFilterBilateralBlurDepthAwareParameters.Builder builder()

      Creates a builder for `R2ShaderFilterBilateralBlurDepthAwareParameters`.
      Returns:
        A new R2ShaderFilterBilateralBlurDepthAwareParameters builder

Copyright © 2017 <code@io7m.com> http://io7m.com